// ************************************************
// SmVR_CPoint.h
//	Implement general functions for point operations
//
//  Authors: Regis Augusto Poli Kopper
//           Mrcio Serolli Pinho 
//	Emails: rkopper@inf.pucrs.br
//          pinho@inf.pucrs,br
//	Homepages:
//		http://www.smallvr.org
//		http://grv.inf.pucrs.br
//		http://www.inf.pucrs.br/~rkopper
//
//	Blacksburg, VA, USA, 2005.
// ************************************************


#include "SmVR_CPoint.h"
#include <math.h>

// ************************************************
//	Method: SmVR_CPoint constructor
//	Description: 
//
//
//
// ************************************************
SmVR_CPoint::SmVR_CPoint() {
	X = 0;
	Y = 0;
	Z = 0;
}
// ************************************************
//	Method: SmVR_CPoint constructor
//	Description: 
//
//
//
// ************************************************
SmVR_CPoint::SmVR_CPoint(GLfloat a, GLfloat b, GLfloat c){
	X = a;
	Y = b;
	Z = c;
}
// ************************************************
//	Method: operator + overloading 
//	Description: 
//
// ************************************************
SmVR_CPoint SmVR_CPoint::operator+(SmVR_CPoint pt){
	SmVR_CPoint ptmp;
	ptmp.X=X+pt.X;
	ptmp.Y=Y+pt.Y;
	ptmp.Z=Z+pt.Z;
	return ptmp;
}

// ************************************************
//	Method: operator - overloading 
//	Description: 
//
// ************************************************
SmVR_CPoint SmVR_CPoint::operator-(SmVR_CPoint pt){
	SmVR_CPoint ptmp;
	ptmp.X=X-pt.X;
	ptmp.Y=Y-pt.Y;
	ptmp.Z=Z-pt.Z;
	return ptmp;
}

// ************************************************
//	Method: operator unary minus overloading 
//	Description: 
//
// ************************************************
SmVR_CPoint SmVR_CPoint::operator-(){
	SmVR_CPoint ptmp;
	ptmp.X=-X;
	ptmp.Y=-Y;
	ptmp.Z=-Z;
	return ptmp;
}


// ************************************************
//	Method: operator - (for constant) overloading 
//	Description: 
//
// ************************************************
SmVR_CPoint SmVR_CPoint::operator-(float val){
	SmVR_CPoint ptmp;
	ptmp.X=X-val;
	ptmp.Y=Y-val;
	ptmp.Z=Z-val;
	return ptmp;
}
// ************************************************
//	Method: operator + (for constant) overloading 
//	Description: 
//
// ************************************************
SmVR_CPoint SmVR_CPoint::operator+(float val){
	SmVR_CPoint ptmp;
	ptmp.X=X+val;
	ptmp.Y=Y+val;
	ptmp.Z=Z+val;
	return ptmp;
}

// ************************************************
//	Method: operator / overloading 
//	Description: 
//
// ************************************************
SmVR_CPoint SmVR_CPoint::operator/(float val){
	SmVR_CPoint ptmp;
	ptmp.X=X/val;
	ptmp.Y=Y/val;
	ptmp.Z=Z/val;
	return ptmp;
}

// ************************************************
//	Method: operator * overloading 
//	Description: 
//
// ************************************************
SmVR_CPoint SmVR_CPoint::operator*(float val){
	return *this/(1/val);
}

// ************************************************
//	Method: operator < overloading 
//	Description: 
//
// ************************************************
bool SmVR_CPoint::operator<(SmVR_CPoint pt){
	printf("%f < %f, %f < %f, %f < %f, %f < %f\n",X,pt.X,Y,pt.Y,Z,pt.Z);
	return(X < pt.X && Y < pt.Y && Z < pt.Z);
}

// ************************************************
//	Method: operator + overloading 
//	Description: 
//
// ************************************************
float SmVR_CPoint::Mod(){
	return sqrt(X*X + Y*Y + Z*Z);
}

// ************************************************
//	Method: operator + overloading 
//	Description: 
//
// ************************************************
void SmVR_CPoint::Normalize(){
	float mod = Mod();
	X /= mod;
	Y /= mod;
	Z /= mod;
}


